package org.processmining.plugins.bpmnminer.plugins;

import javax.swing.JComponent;

import org.deckfour.uitopia.api.event.TaskListener.InteractionResult;
import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.plugins.bpmnminer.ui.AbstractParameterPanel;
import org.processmining.plugins.bpmnminer.ui.SimpleParameterPanel;
import org.processmining.plugins.bpmnminer.visualization.FlowVisualization;

@Plugin(name = "Analyze Process Flows with Fodina", 
		parameterLabels = {"Log"},
		returnLabels = {"Visualization"},
		returnTypes = {
			JComponent.class
		},
		userAccessible = true,
		help = "Analyse Process Flows in Mined Causal Net")

public class FlowAnalysisPlugin {
	
	@UITopiaVariant(affiliation = UITopiaVariant.EHV,
			author = "Seppe K.L.M. vanden Broucke",
			email = "seppe.vandenbroucke@econ.kuleuven.be",
			website = "http://econ.kuleuven.be")
	
	@PluginVariant(variantLabel = "Default", requiredParameterLabels = { 0 })
	public static JComponent ExecutePlugin(UIPluginContext context, XLog log) {
		AbstractParameterPanel parameters = new SimpleParameterPanel();
		InteractionResult result = context.showConfiguration("Miner Parameters", parameters);
		
		if (result.equals(InteractionResult.CANCEL)) {
			context.getFutureResult(0).cancel(true);
			return null;
		}
		
		return FlowVisualization.visualize(context, log, parameters.getSettings());
	}
}
