package org.processmining.plugins.bpmnminer.util;

import org.processmining.framework.connections.DynamicConnection;
import org.processmining.framework.connections.impl.AbstractConnection;
import org.processmining.models.graphbased.directed.bpmn.BPMNDiagram;
import org.processmining.plugins.bpmnminer.causalnet.CausalNet;

public class CausalNetBPMNDiagramConnection extends AbstractConnection implements DynamicConnection {

	private CausalNet causalNet;
	private BPMNDiagram bpmnDiagram;

	public CausalNetBPMNDiagramConnection(String label, CausalNet c, BPMNDiagram d) {
		super(label);
		this.causalNet = c;
		this.bpmnDiagram = d;
		put("CAUSALNET", this.causalNet);
		put("BPMDIAGRAM", this.bpmnDiagram);
	}
	
	public CausalNet getCausalNet() {
		return causalNet;
	}

	public BPMNDiagram getBpmnDiagram() {
		return bpmnDiagram;
	}

}
